.\" 
.\"               Copyright (C) 1993 Hewlett-Packard Company
.\"                          ALL RIGHTS RESERVED.
.\" 
.\"   The enclosed software and documentation includes copyrighted works of
.\"   Hewlett-Packard Co. For as long as you comply with the following
.\"   limitations, you are hereby authorized to (i) use, reproduce, and
.\"   modify the software and documentation, and to (ii) distribute the
.\"   software and documentation, including modifications, for
.\"   non-commercial purposes only.
.\" 
.\"   1.  The enclosed software and documentation is made available at no
.\"       charge.
.\" 
.\"   2.  You may not delete any copyright notices contained in the
.\"       software or documentation. All hard copies, and copies in
.\"       source code or object code form, of the software or
.\"       documentation (including modifications) must contain at least
.\"       one of the copyright notices.
.\" 
.\"   3.  The enclosed software and documentation has not been subjected
.\"       to testing and quality control and is not a Hewlett-Packard Co.
.\"       product. At a future time, Hewlett-Packard Co. may or may not
.\"       offer a version of the software and documentation as a product.
.\" 
.\"   4.  THE SOFTWARE AND DOCUMENTATION IS PROVIDED "AS IS".
.\"       HEWLETT-PACKARD COMPANY DOES NOT WARRANT THAT THE USE,
.\"       REPRODUCTION, MODIFICATION OR DISTRIBUTION OF THE SOFTWARE OR
.\"       DOCUMENTATION WILL NOT INFRINGE A THIRD PARTY'S INTELLECTUAL
.\"       PROPERTY RIGHTS. HP DOES NOT WARRANT THAT THE SOFTWARE OR
.\"       DOCUMENTATION IS ERROR FREE. HP DISCLAIMS ALL WARRANTIES,
.\"       EXPRESS AND IMPLIED, WITH REGARD TO THE SOFTWARE AND THE
.\"       DOCUMENTATION. HP SPECIFICALLY DISCLAIMS ALL WARRANTIES OF
.\"       MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
.\" 
.\"   5.  HEWLETT-PACKARD COMPANY WILL NOT IN ANY EVENT BE LIABLE FOR ANY
.\"       DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
.\"       (INCLUDING LOST PROFITS) RELATED TO ANY USE, REPRODUCTION,
.\"       MODIFICATION, OR DISTRIBUTION FOR THE SOFTWARE OR DOCUMENTATION.
.\" 
.\"
.\"
.\" use the command
.\"
.\" 	tbl hbiff.1 | nroff -man 
.\"
.\" to view this document
.\"
.\"
.TH hbiff 1 "" "" HP-UX
.SH NAME
hbiff - check for incoming mail using X11
.SH SYNOPSIS
.B hbiff
[
.I options
]
.SH DESCRIPTION
.TS
lll.

option	.Xdefaults	description

-display		specifies the display to use 
-u		T{
the user who's mailbox is to be checked
T}
-m		T{
name of the mailbox to be checked
(can be any file)
T}
-H	noHostname	T{
do not display hostname in hbiff window
T}
-fn	fontName	specifies the font to use 
-fg	foreground	specifies the foreground color
-bg	background	specifies the background color
-bc	borderColor	specifies the border color
-bw	borderWidth	specifies the border width
-t	time	T{
specifies the interval for 
checking the mailbox
T}
-pop	newMailRaise	raise to top when new mail
-beep	newMailBeep	T{
notify with sound when new mail
T}
-tally	tally	T{
show number of messages, 
and new messages
T}
-sn	showNewMail	T{
pop up summary window with
information about new mail 
messages when received
T}
-R	newMailReverse	T{
reverse video when new mail
T}
-r	reverseVideo	T{
reverse video (mainly 
useful for monochrome)
T}
-ro	reverseOrder	T{
reverse order of messages 
in summary window
T}
-F	noFlash	do not flash the window
-g =HxW+x+y		T{
the size and placement of the window
T}
	geometry	T{
the size and placement of the window
T}
	newMailForeground	T{
Foreground color when new mail
T}
	newMailBackground	T{
Background color when new mail
T}
	summaryForeground	T{
Foreground color for summary window
T}
	summaryBackground	T{
Background color for summary window
T}
-summaryGeometry =+x+y	summaryGeometry	T{
placement of summary window
T}
	mailCommand	T{
command to execute when 
the right button is pressed
T}
-name \fIstring\fR	name	T{
name to display (if 
not the hostname)
T}
.TE
.TS
c s,
l l.

Example .Xdefaults entries:

hbiff*mailCommand:	hpterm -geometry =80x24+10+15 -e mail
hbiff*borderWidth:	1
hbiff*newMailRaise:	on
hbiff*foreground:	navy
hbiff*background:	wheat
hbiff*fontName:	6x10
hbiff*noHostname:	on
hbiff*newMailForeground:	white
hbiff*newMailBackground:	CornflowerBlue
hbiff*newMailBeep:	on
.TE

.fi
.ad b
.PP
The utility 
.I hbiff
indicates the current state of an electronic mailbox.  The default mailbox is 
.BR /usr/mail/$LOGNAME ,
but an alternate file may be indicated by using the 
.B -m
option.  
.PP
New mail is indicated by a raised flag and mail hanging out of the mailbox, 
and may be accompanied by the window changing color if desired by the user.  
Old mail is indicated by mail hanging out of the mailbox with no flag raised, 
while no mail is indicated by an empty mailbox.  If the 
.B -tally 
option is used (or the 
.B *tally 
resource is on), the total number of messages in the mailbox will be 
displayed, and the number of new messages will be displayed when new mail 
is detected.
.PP
To exit 
.IR hbiff , 
press shift right button, or type "q" with the
cursor in the window.  To get the mail command, press the right
mouse button.  Pressing button2 (the middle button) will cause a
window with the "From" and "subject" line of each mail message to
appear.  During the time the "From" window is visible, if the
right mouse button is pressed on the mailbox window, the "From"
window will go away and the mail command will be executed, all in
one action.  Any other keypresses or button presses while the
"From" window is present will result in the "From" window
disappearing, no other action will occur.  If the mailbox icon
indicates new mail, pressing the left mouse button will cause the
flag to go down (this was requested since some mailers do not use
separate folders, and it is necessary to drop the flag after
deleting mail and exiting the mailer).
.PP
The most recent mail message is indicated with a '>' before it.
.PP
Summary information from new mail messages can be automatically displayed 
by using the 
.B -sn 
option or 
.B *showNewMail 
resource.  When new mail is detected, 
.I hbiff 
will notify the user and then 
pop up a summary window showing only the mail that has been received since 
.I hbiff 
detected that the mailbox was last accessed.
.PP
To turn off window decoration (borders not supplied by the application), use
the 
.B clientDecoration
directive in the 
.I .Xdefaults 
file (i.e., 
.BR Mwm*HBiff.clientDecoration: " +none)."
.PP
For best results when running a command executed by 
.IR hbiff , 
use the 
.B *ttyModes 
resource for the 
.I hpterm 
or 
.I xterm 
you are using.  This allows setting the stty parameters that would 
otherwise be set by the shell on initiation.
.SH AUTHOR
.PP
.I hbiff
was written by Hugh Mahon.
.SH SEE ALSO
xterm(1X), hpterm(1X), elm(1), mailx(1)
